Package htsjdk.samtools

# Enum Class SamReaderFactory.Option

java.lang.Object
java.lang.Enum<SamReaderFactory.Option>
htsjdk.samtools.SamReaderFactory.Option

All Implemented Interfaces:
  `Serializable`, `Comparable<SamReaderFactory.Option>`, `Constable`

Enclosing class:
  `SamReaderFactory`

public static enum SamReaderFactory.Option extends Enum<SamReaderFactory.Option>
A collection of binary `SamReaderFactory` options.

## Nested Class Summary

## Nested classes/interfaces inherited from class java.lang.Enum

`Enum.EnumDesc<E extends Enum<E>>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`CACHE_FILE_BASED_INDEXES`
The factory's `SamReader`s' `SamReader.indexing()`'s calls to `SamReader.Indexing.getIndex()` will produce `BAMIndex`es that do some caching in memory instead of reading the index from the disk for each query operation.
`DONT_MEMORY_MAP_INDEX`
The factory's `SamReader`s' will not use memory mapping for accessing index files (which is used by default).
`EAGERLY_DECODE`
Eagerly decode `SamReader`'s `SAMRecord`s, which can reduce memory footprint if many fields are being read per record, or if fields are going to be updated.
`INCLUDE_SOURCE_IN_RECORDS`
The factory's `SamReader`s will produce populated (non-null) values when calling `SAMRecord.getFileSource()`.
`VALIDATE_CRC_CHECKSUMS`
For `SamReader`s backed by block-compressed streams, enable CRC validation of those streams.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final EnumSet<SamReaderFactory.Option>`
`DEFAULTS`

## Method Summary

Modifier and Type
Method
Description
`static SamReaderFactory.Option`
`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static SamReaderFactory.Option[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### INCLUDE_SOURCE_IN_RECORDS

public static final SamReaderFactory.Option INCLUDE_SOURCE_IN_RECORDS
The factory's `SamReader`s will produce populated (non-null) values when calling `SAMRecord.getFileSource()`.

This option increases memory footprint slightly per `SAMRecord`.

### CACHE_FILE_BASED_INDEXES

public static final SamReaderFactory.Option CACHE_FILE_BASED_INDEXES
The factory's `SamReader`s' `SamReader.indexing()`'s calls to `SamReader.Indexing.getIndex()` will produce `BAMIndex`es that do some caching in memory instead of reading the index from the disk for each query operation.

See Also:
  - `SamReader.indexing()`
  - `SamReader.Indexing.getIndex()`

### DONT_MEMORY_MAP_INDEX

public static final SamReaderFactory.Option DONT_MEMORY_MAP_INDEX
The factory's `SamReader`s' will not use memory mapping for accessing index files (which is used by default). This is slower but more scalable when accessing large numbers of BAM files sequentially.

See Also:
  - `SamReader.indexing()`
  - `SamReader.Indexing.getIndex()`

### EAGERLY_DECODE

public static final SamReaderFactory.Option EAGERLY_DECODE
Eagerly decode `SamReader`'s `SAMRecord`s, which can reduce memory footprint if many fields are being read per record, or if fields are going to be updated.

### VALIDATE_CRC_CHECKSUMS

public static final SamReaderFactory.Option VALIDATE_CRC_CHECKSUMS
For `SamReader`s backed by block-compressed streams, enable CRC validation of those streams. This is an expensive operation, but serves to ensure validity of the stream.

## Field Details

### DEFAULTS

public static final EnumSet<SamReaderFactory.Option> DEFAULTS

## Method Details

### values

public static SamReaderFactory.Option[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static SamReaderFactory.Option valueOf(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null